;*---------------------------------------------------------------------------
;  :Program.	CMP1.asm
;  :Contents.	Decruncher for XFDMaster.Library
;  :Author.	WEPL
;  :History.	0.1	10.11.95
;		0.2	07.01.96 size optimized (2 bytes)
;		0.3	13.01.96 freeing memory if dec failed
;  :Copyright.	Public Domain
;  :Language.	68000 Assembler
;  :Translator.	Barfly 1.130
;---------------------------------------------------------------------------*
;##########################################################################

	INCDIR	Includes:
	INCLUDE	lvo/exec.i
	INCLUDE	libraries/xfdmaster.i

;##########################################################################
;----------------------------------------
; XFD-Library-Header

		moveq	#-1,d0
		rts	

		dc.l	XFDF_ID		;id
		dc.w	XFDF_VERSION	;version
		dc.w	0
		dc.l	0,0		;private
		dc.l	_xfdSlave1	;first slave

;----------------------------------------
; version string

		dc.b	'$VER: CMP1 0.3 '
	DOSCMD	"WDate >T:date"
	INCBIN	T:date
		dc.b	' by WEPL for xfdmaster.library',0
	CNOP 0,4

;----------------------------------------
; xfdSlave-structure

_xfdSlave1	dc.l	0		; next slave
		dc.w	XFDS_VERSION	; structure version
		dc.w	33		; req xfdmaster version
		dc.l	_name1		; cruncher name
		dc.w	XFDPFF_DATA	; cruncher flags
		dc.w	0		; max length of special info (passwd)
		dc.l	_check1		; check routine
		dc.l	_decrunch1	; decrunch routine
		dc.l	0		; segment recog routine
		dc.l	0		; segment decrunch routine

;----------------------------------------
; name of packer

_name1		dc.b	'CMP1 Cruncher',0
	EVEN

;----------------------------------------
; code to check crunched
; bergabe :	D0 = ULONG data size
;		A0 = APTR  data
; Rckgabe :	D0 = BOOL  success

_check1		moveq	#10,d1			;minimum 10 bytes
		cmp.l	d1,d0
		blo	.no
		cmp.l	#"CMP1",(a0)
		bne	.no
		moveq	#-1,d0
		rts

.no		moveq	#0,d0
		rts

;----------------------------------------
; code to decrunch the file
; bergabe :	A0 = APTR xfdBufferInfo
; Rckgabe :	D0 = BOOL success

_decrunch1	movem.l	a4-a6,-(a7)
		move.l	a0,a5				;A5 = xfdbi
		move.l	(xfdbi_SourceBuffer,a5),a4	;A4 = source
		move.l	(4,a4),d0
		move.l	d0,(xfdbi_TargetBufLen,a5)
		move.l	d0,(xfdbi_TargetBufSaveLen,a5)
		move.l	(xfdbi_TargetBufMemType,a5),d1
		move.l	(4).w,a6
		jsr	(_LVOAllocMem,a6)
		move.l	d0,(xfdbi_TargetBuffer,a5)
		bne	.memok
		moveq	#XFDERR_NOMEMORY,d1
		bra	.quit
		
.memok		move.l	d0,a1
		move.l	a4,a0
		move.l	(xfdbi_SourceBufLen,a5),d0
		move.l	(xfdbi_TargetBufLen,a5),d1
		bsr	_CMP1
		tst.l	d0
		bne	.decok
		move.l	(xfdbi_TargetBufLen,a5),d0
		move.l	(xfdbi_TargetBuffer,a5),a1
		jsr	(_LVOFreeMem,a6)
		moveq	#0,d0
		moveq	#XFDERR_CORRUPTEDDATA,d1
		bra	.quit

.decok		moveq	#0,d1		;errcode
		moveq	#-1,d0

.quit		move.w	d1,(xfdbi_Error,a5)
		movem.l	(a7)+,a4-a6
		rts	

;--------------------------------
;	DSA
; simple RUN-LENGTH-COMPRESSION
; 	dc.l	"CMP1"
;	dc.l	ULONG size unpacked
;	dc.b	....  data
; bergabe :	D0 = ULONG size of source buffer
;		A0 = APTR source
;		A1 = APTR destination
; Rckgabe :	D0 = BOOL success

CHKSRC	MACRO
		cmp.l	a0,a2
		beq	.fail
	ENDM

_CMP1		movem.l	d2/a2,-(a7)
		lea	(a0,d0.l),a2	;A2 end of source
		addq.l	#4,a0
		move.l	(a0)+,d0	;D0 = destsize

.2C8C		MOVEQ	#$00,D1
	CHKSRC
		MOVE.B	(A0)+,D1
		BMI.B	.2C8E
.2C8D
	CHKSRC
		MOVE.B	(A0)+,(A1)+
		SUBQ.L	#1,D0
		DBLE	D1,.2C8D
		BRA.B	.2C90

.2C8E		NEG.B	D1
	CHKSRC
		MOVE.B	(A0)+,D2
.2C8F
		MOVE.B	D2,(A1)+
		SUBQ.L	#1,D0
		DBLE	D1,.2C8F
.2C90
		TST.L	D0
		BGT.B	.2C8C

		moveq	#-1,d0		;success
.end		movem.l	(a7)+,d2/a2
		RTS

.fail		moveq	#0,d0		;failure
		bra	.end

;##########################################################################

	END

