;*---------------------------------------------------------------------------
;  :Program.    LOB.asm
;  :Contents.   Decruncher for XFDMaster.Library
;  :Author.     WEPL
;  :Address.    unknown
;  :Shortcut.   unknown
;  :History.    0.1	23.10.95
;		0.2	07.01.96 ID changed, 2 byte less
;		0.3	11.01.96 memory freeing after error
;  :Copyright.  Public Domain
;  :Language.   68000 Assembler
;  :Translator. Barfly 1.130
;---------------------------------------------------------------------------*
;##########################################################################

	INCDIR	Includes:
	INCLUDE	lvo/exec.i
	INCLUDE	libraries/xfdmaster.i

;##########################################################################
;----------------------------------------
; XFD-Library-Header

		moveq	#-1,d0
		rts	

		dc.l	XFDF_ID		;id
		dc.w	XFDF_VERSION	;version
		dc.w	0
		dc.l	0,0		;private
		dc.l	_xfdSlave1	;first slave

;----------------------------------------
; version string

		dc.b	'$VER: LOB 0.3 '
	DOSCMD	"WDate >T:date"
	INCBIN	T:date
		dc.b	' by WEPL for xfdmaster.library',0
	CNOP 0,4

;----------------------------------------
; xfdSlave-structure

_xfdSlave1	dc.l	0		; next slave
		dc.w	XFDS_VERSION	; structure version
		dc.w	33		; req xfdmaster version
		dc.l	_name1		; cruncher name
		dc.w	XFDPFF_DATA	; cruncher flags
		dc.w	0		; max length of special info (passwd)
		dc.l	_check1		; check routine
		dc.l	_decrunch1	; decrunch routine
		dc.l	0		; segment recog routine
		dc.l	0		; segment decrunch routine

;----------------------------------------
; name of packer

_name1		dc.b	'LOB 1-6 Cruncher',0
	EVEN

;----------------------------------------
; code to check crunched
; bergabe :	D0 = ULONG data size
;		A0 = APTR  data
; Rckgabe :	D0 = BOOL  success

_check1		moveq	#16,d1			;minimum 16 bytes
		cmp.l	d1,d0
		blo	.no
		cmp.l	#$014c4f42,(a0)+	;1,"LOB"
		bne	.no
		cmp.b	#6,(a0)			;       ,6
		bne	.no
		moveq	#-1,d0
		rts

.no		moveq	#0,d0
		rts

;----------------------------------------
; code to decrunch the file
; bergabe :	A0 = APTR xfdBufferInfo
; Rckgabe :	D0 = BOOL success

_decrunch1	movem.l	a4-a6,-(a7)
		move.l	a0,a5				;A5 = xfdbi
		move.l	(xfdbi_SourceBuffer,a5),a4	;A4 = source
		move.l	(4,a4),d0
		and.l	#$00ffffff,d0
		move.l	d0,(xfdbi_TargetBufLen,a5)
		move.l	d0,(xfdbi_TargetBufSaveLen,a5)
		move.l	(xfdbi_TargetBufMemType,a5),d1
		move.l	(4).w,a6
		jsr	(_LVOAllocMem,a6)
		move.l	d0,(xfdbi_TargetBuffer,a5)
		bne	.memok
		moveq	#XFDERR_NOMEMORY,d1
		bra	.quit
		
.memok		move.l	d0,a1
		move.l	a4,a0
		move.l	(xfdbi_SourceBufLen,a5),d0
		move.l	(xfdbi_TargetBufLen,a5),d1
		bsr	_LOB
		tst.l	d0
		bne	.decok
		move.l	(xfdbi_TargetBufLen,a5),d0
		move.l	(xfdbi_TargetBuffer,a5),a1
		jsr	(_LVOFreeMem,a6)
		moveq	#0,d0
		moveq	#XFDERR_CORRUPTEDDATA,d1
		bra	.quit
		
.decok		moveq	#-1,d0
		moveq	#0,d1

.quit		move.w	d1,(xfdbi_Error,a5)
		movem.l	(a7)+,a4-a6
		rts

;----------------------------------------
;	Amberstar
;	Ambermoon (AMNP encrypted !)
; sehr hnlich zu TPWM !!! (selber pack algorithmus)
;	dc.b	1,"LOB",6
;	ds.b	24 Bit size decrunched
;	dc.l	size packed - 12
;
; bergabe :	D0 = ULONG size of source buffer
;		D1 = ULONG size of dest buffer
;		A0 = APTR source
;		A1 = APTR destination
; Rckgabe :	D0 = BOOL success

_LOB		movem.l	d2-d7/a2-a4,-(a7)
		lea	(a0,d0.l),a2		;bufend
		addq.l	#8,a0
		move.l	(a0)+,a3
		add.l	a0,a3			;A3 = end of source
		cmp.l	a2,a3			;source buffer large enough ?
		bhi	.fail
		lea	(a1,d1.l),a4		;A4 = end of destination

ChkSrc	MACRO
		cmp.l	a0,a3
		beq	.fail
	ENDM
ChkDst	MACRO
		cmp.l	a1,a4
		beq	.fail
	ENDM

		MOVE.b	#$80,D1			;the 1st X-flag
.5BC		ADD.B	D1,D1
		BNE.B	.5C4
	ChkSrc
		MOVE.B	(A0)+,D1
		ADDX.b	D1,D1
.5C4		BCC.B	.5CE
	ChkSrc
	ChkDst
		MOVE.B	(A0)+,(A1)+
	CMPA.L	a4,A1
	bne	.5BC
	bra	.ok

.5CE		MOVEQ	#0,D3
	ChkSrc
		MOVE.B	(A0)+,D3
		MOVE.B	D3,D2
		ANDI.W	#$000F,D2
		LSL.W	#4,D3
	ChkSrc
		MOVE.B	(A0)+,D3
		MOVEA.L	A1,A2
		SUBA.L	D3,A2
		addq.w	#2,d2
.5E4	ChkDst
		MOVE.B	(A2)+,(A1)+
		DBRA	D2,.5E4
	CMPA.L	a4,A1
	bne	.5BC

.ok		move.l	a0,d0			;D7 is rounded to WordAlign !
		addq.l	#1,d0
		and.b	#%11111110,d0
		cmp.l	d0,a3
		bne	.fail
		moveq	#-1,d0
.quit		movem.l	(a7)+,d2-d7/a2-a4
		rts
.fail		moveq	#0,d0
		bra	.quit

;##########################################################################

	END

